<?php
	// 4 July 2012: fixed encoding on &doc filename and credentials; added &testlink
	// 29 Oct 2012: fixed encoding of + in expressions (must be passed as \+ , e.g. "3 \+ 6" )
	
	$URL = 'http://';
	$ipp = "";
	$doc = "";
	$cmd = "";
	$search = "";
	$format = "";
	$other = "";
	$email = "";
	$subject = "";
	$body = "";
	
	$xmlimport = "<?xml version='1.0'?>";
	
	$prams = $_GET;
	foreach ($_GET as $name => $value){
		switch ($name){
			case "ipp":
				$ipp = $_GET["ipp"];
				break;
				
			case "doc":
				$doc = urlencode($_GET["doc"]);
				break;	
				
			case "cmd":
				$cmd = $_GET["cmd"];
				break;	
			
			//Special cases:
				
			case "data":
			//+ (plus sign) is a reserved character and is treated as a space when used in a URL.
			//Here the client sends "\+" which is recieved as "\ " and replaced by an encoded + sign (%2B)
				$dataValue =  $_GET["data"];
				$plusEncodedValue = str_replace("\ ", "+",$dataValue);
				$plusEncodedValue = str_replace("&", "&amp;",$plusEncodedValue);
				$data = $xmlimport . $plusEncodedValue;
				break;
		
			case "search":
			//+ (plus sign) is a reserved character and is treated as a space when used in a URL.
			//Here the client sends "\+" which is recieved as "\ " and replaced by an encoded + sign (%2B)
				
				$plusEncodedValue = urlencode($value);
				$plusEncodedValue = str_replace("%5C+", "%2B",$plusEncodedValue);
				$search = "&" . $name . "=" . $plusEncodedValue;
				break;	
				
			case "format":
				$format = "&" . $name . "=" . urlencode($value);
				break;	
				
			case "expr":
			//+ (plus sign) is a reserved character and is treated as a space when used in a URL.
			//Here the client sends "\+" which is recieved as "\ " and replaced by an encoded + sign (%2B)
				
				$plusEncodedValue = urlencode($value);
				$plusEncodedValue = str_replace("%5C+", "%2B",$plusEncodedValue);
				$other = $other . "&" . $name . "=" . $plusEncodedValue;
				break;	
				
			case "email":
				$email = $_GET["email"];
				break;		
				
			case "subject":
				$subject = $_GET["subject"];
				break;
				
			case "body":
				$body = $_GET["body"];
				break;
				
			//Auth cases:
				
			case "dcUser":
				$dcUser = urlencode($_GET["dcUser"]);
				break;
				
			case "dcPass":
				$dcPass = urlencode($_GET["dcPass"]);
				break;	
					
			case "docUser":
				$docUser = urlencode($_GET["docUser"]);
				break;
				
			case "docPass":
				$docPass = urlencode($_GET["docPass"]);
				break;	
				
			case "testlink":
				echo "MoneyWorks Rest php is active";
				exit;
				
			default:
				$other = $other . "&" . $name . "=" . $value;
				break;	
		}
	}

	$URL = $ipp  . "/REST/" . $doc  . "/" . $cmd  . "/" . $search . $format . $other;

    $ch = curl_init();
    // set URL and other appropriate options
    curl_setopt($ch, CURLOPT_URL, $URL);
    curl_setopt($ch, CURLOPT_HEADER, 0);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);
	
	if($_GET["data"]){
		curl_setopt($ch, CURLOPT_POSTFIELDS ,$data);
	}
	
    // set Auth headers for Datacentre login, and document login
    $headers = array(
        "Authorization: Basic " . base64_encode($dcUser . ':Datacentre:' . $dcPass),
        "Authorization: Basic " . base64_encode($docUser . ':Document:' . $docPass));
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers); 

    $result = curl_exec($ch);
	$retType = curl_getinfo($ch, CURLINFO_CONTENT_TYPE);
	
    curl_close($ch);
	
	switch($retType){
		case "application/pdf":
			$filename = "/PDF_" . mt_rand(1000,9999) . "_" . date("d:m:Y") . ".pdf";
			header("Content-type: application/pdf"); 
			echo $result;
			if($email != ""){
				savePDF($result, $filename);
				sendEmail($filename);
				unlink(dirname(__FILE__) . $filename);
			}
			break;
			
		case "text/xml":
			echo htmlentities($result);
			break;	
	
		case "text/plain":
			echo $result;
			break;	
			
		case "image/gif":
			header('Content-Type: image/gif');
			echo $result;
			break;	
			
		case "image/jpeg":
			header('Content-Type: image/jpeg');
			echo $result;
			break;	
			
		case "image/tiff":
			header('Content-Type: image/tiff');
			echo $result;
			break;	
			
		case "text/html":
			header('Content-Type: text/html');
			echo $result;
			break;		
				
		default:
			//Used if MIME Type is not caught by the above cases, add more cases if response is incorrect.
			//use echo $retType; to see response type
			echo htmlentities($result);
			break;
	}
	
	function savePDF($data, $_filename){
		$filename = $_filename;
		header("Content-type: application/pdf"); 
		header("Content-Length: $len"); 
		header("Content-Disposition: inline; filename= $filename");
		file_put_contents(dirname(__FILE__) . $_filename,$data);
	}
	
	function sendEmail($filename){
		$my_file = $filename;
		$my_path = dirname(__FILE__);
		$my_name = "MW App";
		$my_mail = "my@mail.com";
		$my_replyto = "my_reply_to@mail.net";
		if($GLOBALS['subject'] == ""){
			$my_subject = "PDF from MoneyWorks Datacentre.";
		}else{
			$my_subject = $GLOBALS['subject'];
		}
		if($GLOBALS['body'] == ""){
			$my_message = "You will find your MoneyWorks PDF attatched to this email.\r\n\r\nMW App";
		}else{
			$my_message = $GLOBALS['body'];
		}
		mail_attachment($my_file, $my_path, $GLOBALS['email'], $my_mail, $my_name, $my_replyto, $my_subject, $my_message);
	}
	
	function mail_attachment($filename, $path, $mailto, $from_mail, $from_name, $replyto, $subject, $message) {
	    $file = $path.$filename;
	    $file_size = filesize($file);
	    $handle = fopen($file, "r");
	    $content = fread($handle, $file_size);
	    fclose($handle);
	    $content = chunk_split(base64_encode($content));
	    $uid = md5(uniqid(time()));
	    $name = basename($file);
	    $header = "From: ".$from_name." <".$from_mail.">\r\n";
	    $header .= "Reply-To: ".$replyto."\r\n";
	    $header .= "MIME-Version: 1.0\r\n";
	    $header .= "Content-Type: multipart/mixed; boundary=\"".$uid."\"\r\n\r\n";
	    $header .= "This is a multi-part message in MIME format.\r\n";
	    $header .= "--".$uid."\r\n";
	    $header .= "Content-type:text/plain; charset=iso-8859-1\r\n";
	    $header .= "Content-Transfer-Encoding: 7bit\r\n\r\n";
	    $header .= $message."\r\n\r\n";
	    $header .= "--".$uid."\r\n";
	    $header .= "Content-Type: application/pdf; name=\"".$filename."\"\r\n"; // use different content types here
	    $header .= "Content-Transfer-Encoding: base64\r\n";
	    $header .= "Content-Disposition: attachment; filename=\"".$filename."\"\r\n\r\n";
	    $header .= $content."\r\n\r\n";
	    $header .= "--".$uid."--";
	    if (mail($mailto, $subject, "", $header)) {
	        echo "mail send ... OK"; // or use booleans here
	    } else {
	        echo "mail send ... ERROR!";
		}
	}
	
?>